<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Class: UserService</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Class: UserService</h1>

    




<section>

<header>
    
        <h2><span class="attribs"><span class="type-signature"></span></span>UserService<span class="signature">()</span><span class="type-signature"></span></h2>
        
            <div class="class-description">User service layer facilitates requests from the controller </br>to the database</div>
        
    
</header>

<article>
    <div class="container-overview">
    
        

    
    <h2>Constructor</h2>
    

    
    <h4 class="name" id="UserService"><span class="type-signature"></span>new UserService<span class="signature">()</span><span class="type-signature"></span></h4>
    

    















<dl class="details">

    

    

    

    

    

    

    

    

    
    <dt class="tag-author">Author:</dt>
    <dd class="tag-author">
        <ul>
            <li>Farooq Ilyas</li>
        </ul>
    </dd>
    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="services_UserService.js.html">services/UserService.js</a>, <a href="services_UserService.js.html#line19">line 19</a>
    </li></ul></dd>
    

    

    

    
</dl>


















    
    </div>

    

    

    

    

    

    

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    
    <h4 class="name" id="create"><span class="type-signature"></span>create<span class="signature">(user)</span><span class="type-signature"> &rarr; {UserInstance}</span></h4>
    

    



<div class="description">
    Queries the database to create a user
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>user</code></td>
            

            <td class="type">
            
                
<span class="param-type">UserAttributes</span>


            
            </td>

            

            

            <td class="description last">user attributes</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="services_UserService.js.html">services/UserService.js</a>, <a href="services_UserService.js.html#line25">line 25</a>
    </li></ul></dd>
    

    

    

    
</dl>













<h5>Returns:</h5>

        
<div class="param-desc">
    user
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">UserInstance</span>


    </dd>
</dl>

    





        
            

    

    
    <h4 class="name" id="delete"><span class="type-signature"></span>delete<span class="signature">(userId)</span><span class="type-signature"> &rarr; {number|JSON}</span></h4>
    

    



<div class="description">
    Queries the database to delete a user given the id
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>userId</code></td>
            

            <td class="type">
            
                
<span class="param-type">number</span>


            
            </td>

            

            

            <td class="description last">userId</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="services_UserService.js.html">services/UserService.js</a>, <a href="services_UserService.js.html#line80">line 80</a>
    </li></ul></dd>
    

    

    

    
</dl>













<h5>Returns:</h5>
<ul>
        <li>
<div class="param-desc">
    rows deleted
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">number</span>


    </dd>
</dl>
</li>
    
        <li>
<div class="param-desc">
    user if id not found
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">JSON</span>


    </dd>
</dl>
</li>
    </ul>





        
            

    

    
    <h4 class="name" id="retrieve"><span class="type-signature"></span>retrieve<span class="signature">()</span><span class="type-signature"> &rarr; {Array.&lt;UserInstance>}</span></h4>
    

    



<div class="description">
    Queries the database to retrieve all users
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="services_UserService.js.html">services/UserService.js</a>, <a href="services_UserService.js.html#line41">line 41</a>
    </li></ul></dd>
    

    

    

    
</dl>













<h5>Returns:</h5>

        
<div class="param-desc">
    all users
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Array.&lt;UserInstance></span>


    </dd>
</dl>

    





        
            

    

    
    <h4 class="name" id="retrieveById"><span class="type-signature"></span>retrieveById<span class="signature">(userId)</span><span class="type-signature"> &rarr; {UserInstance|JSON}</span></h4>
    

    



<div class="description">
    Queries the database to retrieve a user given the id
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>userId</code></td>
            

            <td class="type">
            
                
<span class="param-type">number</span>


            
            </td>

            

            

            <td class="description last">user id</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="services_UserService.js.html">services/UserService.js</a>, <a href="services_UserService.js.html#line59">line 59</a>
    </li></ul></dd>
    

    

    

    
</dl>













<h5>Returns:</h5>
<ul>
        <li>
<div class="param-desc">
    upon successful retrieval
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">UserInstance</span>


    </dd>
</dl>
</li>
    
        <li>
<div class="param-desc">
    if user id not found
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">JSON</span>


    </dd>
</dl>
</li>
    </ul>





        
            

    

    
    <h4 class="name" id="update"><span class="type-signature"></span>update<span class="signature">(userId, userAttributes)</span><span class="type-signature"> &rarr; {UserInstance}</span></h4>
    

    



<div class="description">
    Queries the database to update a user given the id
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>userId</code></td>
            

            <td class="type">
            
                
<span class="param-type">number</span>


            
            </td>

            

            

            <td class="description last">user id</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>userAttributes</code></td>
            

            <td class="type">
            
                
<span class="param-type">UserAttributes</span>


            
            </td>

            

            

            <td class="description last">user attributes</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="services_UserService.js.html">services/UserService.js</a>, <a href="services_UserService.js.html#line101">line 101</a>
    </li></ul></dd>
    

    

    

    
</dl>













<h5>Returns:</h5>

        
<div class="param-desc">
    updated user
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">UserInstance</span>


    </dd>
</dl>

    





        
    

    

    
</article>

</section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="BaseRouter.html">BaseRouter</a></li><li><a href="Configs.html">Configs</a></li><li><a href="CustomErrorHandler.html">CustomErrorHandler</a></li><li><a href="Database.html">Database</a></li><li><a href="DBConfig.html">DBConfig</a></li><li><a href="LoggingConfiguration.html">LoggingConfiguration</a></li><li><a href="Middleware.html">Middleware</a></li><li><a href="Server.html">Server</a></li><li><a href="ServerConfiguration.html">ServerConfiguration</a></li><li><a href="UserController.html">UserController</a></li><li><a href="UserModel.html">UserModel</a></li><li><a href="UserRouter.html">UserRouter</a></li><li><a href="UserService.html">UserService</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Mon Jul 02 2018 23:16:09 GMT+0100 (GMT Daylight Time)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>